<template lang="pug">
  .memberchat.br3.bg-white.pa3.ba.b--gray.flex.flex-column.h-100
    .flex.justify-between.pb3
      nuxt-link.dim.flex.items-center(:to="chatPath")
        .w2.mr2.dib.cover.br-100.bg-moon-gray(:style="avatarStyle")
          .aspect-ratio.aspect-ratio--1x1
        .dib.black {{profile.name}}
          i.fas.fa-link.ml1.light-silver
      b-tooltip(
        label="標為已讀"
        position="is-bottom"
        type="is-info"
      )
        .br-pill.bg-light-gray.f6.pv1.ph3.flex.items-center.pointer.dim(
          @click="markAsRead"
        )
          .br.b--gray.pr2 {{zh(booking.buildingId)}} {{booking.roomId}}
          .pl2
            i.fa.fab.fa-check
    .memberchat__logview.pv2.bb.bt.b--gray.overflow-hidden(ref="logview")
      nuxt-link.black(:to="chatPath")
        chat-log-view(:logs="logs" :limit="5")
    .pt3
      .black(v-show="!tickets.length") 尚無任何通報紀錄
      nuxt-link.br-pill.bg-light-yellow.pv1.ph3.dib.mr2.mb2.f7.lh-copy.black(
        v-for="ticket in tickets"
        :key="ticket.id"
        :to="`/item/${ticket.id}`"
        :class="{'o-50': ticket.state === '已結案'}"
      )
        | {{zh(ticket.taskType)}}
</template>
<script>
import { issueMixin } from '~/utils/mixins'
import api from '~/utils/api'
import ChatLogView from '~/components/ChatLogView'

export default {
  components: {
    ChatLogView
  },
  mixins: [issueMixin],
  props: {
    memberchat: {
      type: Object,
      required: true
    }
  },
  computed: {
    chatPath () {
      return `/chat/all/${this.booking.buildingId}/${this.booking.roomId}`
    },
    booking () {
      return this.memberchat.booking || {}
    },
    profile () {
      if (this.booking.channelMeta) {
        return this.memberchat.booking.channelMeta
      }
      return {}
    },
    avatarStyle () {
      return {
        backgroundImage: `url('${this.profile.profilePic}')`
      }
    },
    tickets () {
      return this.memberchat.tickets
    },
    logs () {
      if (this.memberchat.logs) {
        return this.memberchat.logs
      }
      return []
    }
  },
  watch: {
    logs () {
      this.scrollDown()
    }
  },
  mounted () {
    this.scrollDown()
  },
  methods: {
    async markAsRead () {
      await api.chat.markAsRead(this.memberchat.id)
      this.$emit('read', this.memberchat.id)
    },
    scrollDown () {
      this.$nextTick(() => {
        const target = this.$refs.logview
        if (target) {
          target.scrollTop = target.scrollHeight
        }
      })
    }
  }
}
</script>
<style lang="scss" scoped>
.memberchat {
  &__logview {
    height: 16rem;
  }
}
</style>
